function s0 = flip(s),

% FLIP flip the lens prescription 
% with the last element starting at the origin
% and the first element lying negatively from zero. 
% 
% s = flip(s),
% 
% where 
%       s = optics class

s0 = s;

for k = 1:s.total,
    s0.optics{k} = s.optics{s.total - k + 1};
end

% should start with an index & end in an image plane 
if (mod(s.total,2) == 0),
    nstart = 1;
else 
    nstart = 2;
end

zpos = get(s0.optics{nstart},'position');
for k = nstart:2:s.total,
    
    z0 = zpos - get(s0.optics{k},'position');
    s0.optics{k} = set(s0.optics{k},'position',z0); 
    
    % negate flipped optics 
    s1 = s0.optics{k};
    strType = lower(get(s1,'type'));
    if (strcmp(strType,'ellipsoid')|strcmp(strType,'sphere'))
        s0.optics{k} = set(s1,'abc', -get(s1,'abc'));
    elseif (strcmp(strType,'quadric'))
        s0.optics{k} = set(s1,'R', -get(s1,'R'));
    end
    
    
end;

%  prt_optics(X0);
   
return

   