function [s, t] = seek(s,nfield,nval,nstart),

% SEEK  find the element which has
% where contents of nfield is nval.  
% Start from the next element or the nstart element.
% 
% s = seek(s,nfield,nval,nstart)
%
% where 
%       nfield  = field-name
%       nval    = value 
%       nstart  = start index


  if (nargin < 3),
    s.current = nfield;
    return
  end 

  % default - seek from current+1
  if  ~exist('nstart'),
      thisoptic = s.current + 1; % 10/3/04
  else
      thisoptic = nstart;
  end

  lastoptic = s.total;
  for t = thisoptic:lastoptic,

       % need to look inside a primitive
       prim = struct(s.optics{t});              

       if  strcmp(getfield(prim,nfield), nval) 
           s.current = t;
           s.lasterr = 0;
           return
       end
   end
   s.lasterr = 1;
  
return
