function [s, t] = seek(s, varargin), 

% SEEK go to the element starting from the current element.
%
% SEEK(s, strField, pDesc). Set the prescription to the optic  
% with field strField set to value of pDesc.
% 
% SEEK(s, nID). Set the prescription to the (nID)^th surface.
%
 
if (nargin == 2), % SEEK(s, nID)
   nID = varargin{1};
   if ((nID<1)|(nID > s.total)),
      error('(SEEK) Requested ID out of range.');
   end
   s.current = varargin{1};
   return
elseif (nargin == 3), % SEEK(s, strField, pDesc)
   for t = s.current:s.total,
     pr = s.optic{t};  
     strField = varargin{1};
     pDesc    = varargin{2};
     if  strcmp(get(pr, strField), pDesc) 
         s.current = t;
         return
     end
   end
   error('(SEEK) Element not found.');
else
    error('(SEEK) Invalid invocation.');
end
  
return