function print(p),

% PRINT a text version of the surface.
%
% PRINT(prim). prim is a primitive object
%
 
% default options
fprintf('PRIM = "%s"\n', p.type);
% current arguments.
fprintf('ARGUMENTS\n');
if (isempty(p.args.name)),
  fprintf('  [EMPTY]\n'); 
else 
   for k = 1:length(p.args.name),       
     if (isnumeric(p.args.value{k})),
        if (length(p.args.value{k}) == 1),
            s0 = fprintf('    %s = %2.6f\n', p.args.name{k}, p.args.value{k}); 
        elseif (size(p.args.value{k}, 2) == 1), 
            s0 = fprintf('    %s =\n', p.args.name{k});
            n = p.args.value{k}; l = 1:length(p.args.value{k});
            s0 = fprintf('         %d. %2.6f\n', [ l(:), n(:) ]'); 
        end
     elseif (ischar(p.args.value{k})), 
        s0 = fprintf('    %s = "%s"\n', p.args.name{k}, p.args.value{k});
     else 
        error('(PRIM/PRINT) inconsistent value found.');
     end
   end 
end


% current arguments.
fprintf('DETAILS\n');
fprintf('  description = "%s"\n', p.description); 

% standard options    
if (~strcmp(lower(p.type), 'index')),          
    s0 = fprintf('  position    = (%2.4f, %2.4f, %2.4f)\n', p.position); 
    s0 = fprintf('  orientation = (%2.4f, %2.4f, %2.4f)\n', p.orientation); 
    s0 = fprintf('  aperture    = (%2.4f)\n', p.aperture); 
    s0 = fprintf('  refraction  = "%s"\n', p.refraction); 
    if (~isnan(p.etol)),
        s0 = fprintf('  tol.        = %2.4e\n', p.etol); 
    end
end
return