function [rays,I] = traceto(rays, myelement, I),

% TRACETO call the correct functions to do the tracing.
% 
% [rays, I] = traceto(myelement,rays,I),
%
% assuming surface centered frame. 

% 23/12 added creation of default index created if not supplied 


if (nargin == 2),
    I = (1:length(rays))';
end 

        myelement = struct(myelement);        
        label = lower(myelement.type);

        % myelement
        % show(rays)
        
        switch(label)
            
          case { 'conic' }  
                            
            info.CC         = myelement.CC;
            info.R          = myelement.R;
            info.aperture   = myelement.aperture;
            info.sense      = myelement.sense;
            
            show(rays);
            
            [rays, I]         = traceto_conic(rays, info, I);
  
          case  { 'asphere', } 

            Q = myelement.Q; R = myelement.R;
            info = [ -R/sqrt(1+Q) -R/sqrt(1+Q) -R ];
            [rays, I]     = traceto_ellipsoid(rays, info, myelement.aperture, I);
           
          case { 'ellipsoid','sphere' }
              
            show(rays); 
            [rays, I]     = traceto_ellipsoid(rays, myelement.abc, myelement.aperture, I);
                        
          case  { 'quadric' }

            % massage the data a bit
            info.Q         = myelement.Q;
            info.R         = myelement.R;
            info.aperture  = myelement.aperture;
            info.sense     = myelement.sense;  
            [rays, I]      = traceto_quadric(rays, info, I);
            
            
        case  { 'plane', 'pupil','image'}

            [ rays, I ] = traceto_plane(rays, myelement.aperture, I);
            if  isempty(rays)
                mdisp([ 'traceto: no rays traced to ' label ]);
                return
            end
                   
        case  { 'zernike','bspline','keratotomy','rksphere' }

            fprintf('about to rksphere ...\n');
            keyboard;
            
            [ rays, I ] = traceto_general(rays, myelement, I);
            if  isempty(rays)
                mdisp([ 'traceto: no rays traced to ' label ]);
                return
            end

            
        case 'index',
             error('optics definition faulty - cant trace an index element');

             % case  { 'toroid' }
             % case  { 'quadric' }
             % case  { 'bspline' }
             % case  { 'zernike' }
             
        otherwise
             error([ 'unknown optical element ' label ]);
             
    end

return
