function [s, I1] = traceto_ellipsoid(s, info, dr, I1)

% TRACETO_ELLIPSOID ellipse intersection re-coded to try and get some
% speed out of it.  rays that dont hit the extent are removed
% altogether
%
% [s, I] = traceto_ellipsoid(rays, info, dr, I1)
% 
%  InInfoA  = posn
%  InInfoB  = rays  
%  InInfoC  = [a.b.c]
%  I1       = indexes 
%
%  surface centered 
%
% reformatted 9/11/04

% disp('wrapper ellipsoid');

X0          = get(s,'posn');
M           = get(s,'slope');
OPL         = get(s,'OPL');
nindex      = get(s,'index');

origin      = [0 0 0];
InInfo      = [ origin info dr ];    % origin,abc,dr

ndx     = (1:size(X0,1))';  % internal index
[X M ndx]     = trayelp1(X0, M, InInfo, ndx);

% update OPL
I1          = I1(ndx);
OPL         = OPL(ndx);
X0          = X0(ndx,:);

if (isempty(I1)),
        s = set(s,'posn',[]);
        s = set(s,'slope',[]);
        s = set(s,'OPL',[]);
        return 
end

dz  = X(:,3) - X0(:,3);
ds  = M(:,3);
new_OPL     = nindex*sign(dz.*ds).*vec_norm(X-X0) + OPL;

s = set(s,'posn',X);
s = set(s,'slope',M);
s = set(s,'OPL',new_OPL);

return
