function [s,I1] = traceto_general(s, info, I1)

% TRACETO_GENERAL  origin centered general surface 
%
%   [s,I1] = traceto_general(s, ap, I1)
% 
% where 
%
%       s = object of type <psurf> 
%
% 27/7/05 Safety Implementation Required  
% 
% Aperture Error a possibility

X0      = get(s,'posn');
M       = get(s,'slope');
OPL     = get(s,'OPL');
nindex  = get(s,'index');

% info    = [ 0 0 0 ap 0 ];

ndx         = (1:size(X0,1))';  % internal index
[X,M,ndx]   = general(X0, M, info, ndx);

% update OPL
I1          = I1(ndx);
OPL         = OPL(ndx);
X0          = X0(ndx,:);

if (isempty(I1)),
        s = set(s,'posn',[]);
        s = set(s,'slope',[]);
        s = set(s,'OPL',[]);
        return 
end

dz  = X(:,3) - X0(:,3);
ds  = M(:,3);
new_OPL     = nindex*sign(dz.*ds).*vec_norm(X-X0) + OPL;

s = set(s,'posn',X);
s = set(s,'slope',M);
s = set(s,'OPL',new_OPL);
return

function [X, M, ndx] = general(X0, M, info, ndx);

    % 
    % eye back model
    % 
    %   tg(:,1:2) initial target point 
    %   S         initial source points
    %   eye       backpath eye model 
    %   tg        actual required targets
   
    
    %  s =  estimated length to the surface 
    s   = -vec_norm(X0).*sign(X0(:,3));  % fire at origin 
    [s, fval]   = brent('m_zernike', s, [X0 M]', info);

    i = isnan(s);
    if (any(i)),
        i = ~i;
        X0  = X0(i,:);
        M0  = M0(i,:);
        s   = s(i);
        ndx = ndx(i);
    end 
    
    s = M*0 + s;
    X = X0 + s.*M;
    
    disp('returning');
    X
    X0
    s
    M
        
return