function [s,I1] = traceto_plane(s, ap, I1)

% TRACETO_PLANE  origin centered plane 
%
% [s,I1] = traceto_plane(s, ap, I1)
% 
% InInfoA =
% InInfoB =
% InInfoC =
% I1      = 

% InInfo    = [ origin myelement.aperture 0 ];
            

X0      = get(s,'posn');
M       = get(s,'slope');
OPL     = get(s,'OPL');
nindex  = get(s,'index');

info    = [ 0 0 0 ap 0 ];

ndx     = (1:size(X0,1))';  % internal index
[X,M,ndx] = traypln1(X0, M, info, ndx);

% update OPL
I1          = I1(ndx);
OPL         = OPL(ndx);
X0          = X0(ndx,:);


if (isempty(I1)),
        s = set(s,'posn',[]);
        s = set(s,'slope',[]);
        s = set(s,'OPL',[]);
        return 
end

dz  = X(:,3) - X0(:,3);
ds  = M(:,3);
new_OPL     = nindex*sign(dz.*ds).*vec_norm(X-X0) + OPL;

s = set(s,'posn',X);
s = set(s,'slope',M);
s = set(s,'OPL',new_OPL);
return
