function [w, pupil] = pfnAiry(N, k),
%
% PFNAIRY Pupil Function for a wavefront with zero error.
% leads to the Airy function. 
%
% PFNAIRY(N, k). Here N is the grid size and 1/k is the proportion of the 
% grid that the aperture fills.  If no arguments are specified the default 
% will be PFNAIRY(128, 8).
%
%  Example,

%   [w, pupil] = pfnAiry(128, 1);  
%
% Taken from :
% http://www.engr.udayton.edu/faculty/jloomis/eop601/matlab/psf/fft_psf.html
% last accessed : Feb 2007

if (nargin == 0),
    N = 128;
    k = 8;
end 

pupil = make_pupil(N,2*k);    % construct the pupil function
rmax = N/(4*k);
w = zeros(N,N);               % perfect wavefront

% complex pupil fn. 
% z = pupil.*exp(2*pi*j*w);
return